package com.sulake.habbo.catalog;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.sulake.habbo.catalog.types.CatalogItem;
import com.sulake.habbo.catalog.types.CatalogPage;
import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.utilities.Logger;

public class CatalogManager {

	private Map<Integer, CatalogPage> ShopPages;
	private int itemCount = 0;

	public CatalogManager() {

		this.ShopPages = new HashMap<Integer, CatalogPage>();
	}

	public void loadAll(DatabaseManager db) {
		
		this.getPages().clear();
		itemCount = 0;
		
		try {
			ResultSet page = db.readTable("SELECT * FROM catalog_pages");

			while(page.next()) {
				
				List<CatalogItem> items = this.loadItems(db, page.getInt("id"));

				CatalogPage p = new CatalogPage(page.getInt("id"), page.getString("caption"), page.getInt("icon_image"), page.getInt("icon_color"), page.getInt("min_rank"), page.getString("page_layout"), page.getInt("parent_id"), items, page.getString("page_headline"), page.getString("page_teaser"), page.getString("page_special"), page.getString("page_text1"), page.getString("page_text2"), page.getString("page_text_details"), page.getString("page_text_teaser"), page.getString("enabled").equals("1"));
				this.getPages().put(p.Id, p);
				
				items.clear();
			}

		} catch(Exception e) {
			e.printStackTrace();
		}
		
		Logger.write("Loaded " + this.getPages().size() + " catalog pages and " + itemCount + " catalog items");
	}

	public ArrayList<CatalogItem> loadItems(DatabaseManager db, int pageId) throws SQLException {
		ArrayList<CatalogItem> items = new ArrayList<CatalogItem>(); 
		ResultSet item = db.readTable("SELECT * FROM catalog_items WHERE page_id = " + pageId);

		while(item.next()) {
			itemCount = itemCount + 1;
			CatalogItem i = new CatalogItem(item.getInt("id"), item.getInt("item_ids"), item.getString("catalog_name"), item.getInt("cost_credits"), item.getInt("cost_pixels"), item.getInt("cost_snow"), item.getInt("amount"), false);

			items.add(i);
		}

		return items;
	}

	public CatalogPage getPage(int id) {
		if(this.getPages().containsKey(id)) {
			return this.getPages().get(id);
		}

		return null;
	}

	public Map<Integer, CatalogPage> getPages() {
		return this.ShopPages;
	}
}