package com.sulake.habbo.catalog.types;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.sulake.habbo.communication.messages.types.Composer;

public class CatalogPage
{
    public int Id;
    public String Caption;
    public int Icon;
    public int Colour;
    public int MinRank;
    public String Template;
    public int ParentId;

    public Map<Integer, CatalogItem> Items;

    public String Headline;
    public String Teaser;
    public String Special;
    public String Text1;
    public String Text2;
    public String Details;
    public String Teaser2;
	public boolean Enabled;
    
    public CatalogPage(int Id, String Caption, int Icon, int Colour, int MinRank, String Template, int ParentId, List<CatalogItem> Items, String Headline, String Teaser, String Special, String Text1, String Text2, String Details, String Teaser2, boolean Enabled)
    {
        this.Id = Id;
        this.Caption = Caption;
        this.Icon = Icon;
        this.Colour = Colour;
        this.MinRank = MinRank;
        this.Template = Template;

        this.ParentId = ParentId;
        
        this.Headline = Headline;
        this.Teaser = Teaser;
		this.Special = Special;
		this.Text1 = Text1;
		this.Text2 = Text2;
		this.Details = Details;
		this.Teaser2 = Teaser2;
		
		Map<Integer, CatalogItem> pageItems = new HashMap<Integer, CatalogItem>();
		
		for(CatalogItem item : Items) {
			pageItems.put(item.Id, item);
		}
		
		this.Items = pageItems;
    }
    
    public void serialize(Composer msg) {
    	msg.appendInt32(this.Items.size());

		for(CatalogItem item : this.Items.values()) {

			msg.appendInt32(item.Id);
			msg.appendString(item.DisplayName);
			msg.appendInt32(item.CostCredits);
	
			if(item.CostOther > 0) {
				msg.appendInt32(item.CostOther);
				msg.appendInt32(105);
			} else {
				msg.appendInt32(item.CostPixels);
				msg.appendInt32(0);
			}

			msg.appendBoolean(true);
			msg.appendInt32(1);
			msg.appendString(item.getDefinition().ItemType);
			msg.appendInt32(item.getDefinition().SpriteId);
			msg.appendString("");
			msg.appendInt32(item.Amount);
			msg.appendInt32(-1);
			msg.appendBoolean(false);
			msg.appendInt32(item.Vip ? 1 : 0);
			msg.appendBoolean(false);
		}
    }
    
    public Map<Integer, CatalogItem> getItems() {
    	return this.Items;
    }
    
    public int getId() {
		return Id;
	}

	public String getLayout() {
		return Template;
	}

	public String getTeaser() {
		return Teaser;
	}

	public String getSpecial() {
		return Special;
	}

	public String getText1() {
		return Text1;
	}

	public String getText2() {
		return Text2;
	}

	public String getDetails() {
		return Details;
	}

	public String getTeaser2() {
		return Teaser2;
	}
}