package com.sulake.habbo.communication;

import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.ChannelStateEvent;
import org.jboss.netty.channel.ExceptionEvent;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelHandler;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.utilities.Logger;
import com.sulake.sessions.types.Session;


public class ClientHandler extends SimpleChannelHandler {

	@Override
	public void channelOpen(ChannelHandlerContext ctnx, ChannelStateEvent e) {
		Logger.write("Connection recieved from " + ctnx.getChannel().getRemoteAddress().toString());
	}
	
	@Override
	public void channelClosed(ChannelHandlerContext ctnx, ChannelStateEvent e) {
		
		Session session = (Session)ctnx.getChannel().getAttachment();
		
		if(session != null) {
			session.onLogout();
		}
		
		Logger.write("Connection closed from " + ctnx.getChannel().getRemoteAddress().toString());
		
		Habbo.getCore().getSessions().removeSession(ctnx.getChannel());
	}
	
	@Override	
	public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) {
		
		Session session = (Session)ctx.getChannel().getAttachment();
		
		if(session == null) {
			if(!Habbo.getCore().getSessions().addSession(ctx.getChannel())) {
				ctx.getChannel().disconnect();
			}
		}
		
		Event msg = (Event) e.getMessage();
		
		Habbo.getCore().getMessageHandler().handleEvent(msg, session);
		
	}
	
	@Override
	public void exceptionCaught(ChannelHandlerContext ctx, ExceptionEvent e) {
		ctx.getChannel().close();
	}
}
