package com.sulake.habbo.communication.codec;

import java.nio.ByteBuffer;

import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.channel.Channel;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.handler.codec.frame.FrameDecoder;

import com.sulake.habbo.communication.messages.types.Event;

public class Decoder extends FrameDecoder {

	@Override
	protected Object decode(ChannelHandlerContext Context, Channel channel,
			ChannelBuffer buffer) throws Exception {

		try 
		{			
			/*
			 * If the received packet has enough units to be parsed
			 */
			if (buffer.readableBytes() < 6)
				return null;

			/*
			 * Read the length of our packet
			 */
			byte[] Length = buffer.readBytes(4).array();

			/*
			 * If the length is the char id of the policy.
			 */
			if (Length[0] == 60)
			{
				buffer.discardReadBytes();

				channel.write("<?xml version=\"1.0\"?>\r\n"
					+ "<!DOCTYPE cross-domain-policy SYSTEM \"/xml/dtds/cross-domain-policy.dtd\">\r\n"
					+ "<cross-domain-policy>\r\n"
					+ "<allow-access-from domain=\"*\" to-ports=\"*\" />\r\n"
					+ "</cross-domain-policy>\0");
			}
			else
			{
				/*
				 * Convert the message length so we know how much to read 8)
				 */
				int MessageLength = ByteBuffer.wrap(Length).asIntBuffer().get();

				/*
				 * Create new channel buffer
				 */
				ChannelBuffer MessageBuffer = buffer.readBytes(MessageLength);

				/*
				 * Get header
				 */
				Short HeaderId = MessageBuffer.readShort();

				/*
				 * Make a new request
				 */
				Event event = new Event(HeaderId, MessageBuffer);
				
				return event;
			}		
		}
		catch (Exception e)
		{
		}
		return null;
	}


}
