package com.sulake.habbo.communication.codec;

import java.nio.charset.Charset;

import org.jboss.netty.buffer.ChannelBuffers;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.Channels;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelHandler;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.utilities.Logger;

public class Encoder extends SimpleChannelHandler
{
	@Override
	public void writeRequested(ChannelHandlerContext ctx, MessageEvent e)
	{
		try
		{
			if (e.getMessage() instanceof String)
			{
				Channels.write(ctx, e.getFuture(), ChannelBuffers.copiedBuffer(
						(String) e.getMessage(), Charset.forName("UTF-8")));

				return;
			}
			if (e.getMessage() instanceof Composer)
			{
				Composer msg = (Composer) e.getMessage();
				Channels.write(ctx, e.getFuture(), msg.get());
				
				Logger.write("[SND][" + msg.getHeader() + "][" + Composers.valueOfId(msg.getHeader()) + "] " + msg.getBodyString());
				
				return;
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
}

