package com.sulake.habbo.communication.messages.catalog;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.catalog.types.CatalogPage;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.sessions.types.Session;

public class OpenCatalogMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		Composer msg = new Composer(Composers.OpenShopMessageComposer);
		
		msg.appendBoolean(true);
		msg.appendInt32(0);
		msg.appendInt32(0);
		msg.appendInt32(-1);
		msg.appendString("root");
		msg.appendBoolean(false);
		msg.appendBoolean(false);
		
		msg.appendInt32(catCount(-1)); // size
		
		for(CatalogPage page :  Habbo.getCore().getCatalog().getPages().values()) {
			if(page.ParentId != -1) {
				continue;
			}
			
			msg.appendBoolean(true);
			msg.appendInt32(page.Colour);
			msg.appendInt32(page.Icon);
			msg.appendInt32(page.Id);
			msg.appendString(page.Caption.toLowerCase().replace(" ", "_"));
			msg.appendString(page.Caption);
			
			msg.appendInt32(catCount(page.Id));
			
			for(CatalogPage child : Habbo.getCore().getCatalog().getPages().values()) {
				if(child.ParentId != page.Id) {
					continue;
				}
				
				msg.appendBoolean(true);
				msg.appendInt32(child.Colour);
				msg.appendInt32(child.Icon);
				msg.appendInt32(child.Id);
				msg.appendString(child.Caption.toLowerCase().replace(" ", "_"));
				msg.appendString(child.Caption);
				msg.appendInt32(0);
			}
		}
		
		msg.appendBoolean(true);
		
		client.send(msg);
	}
	
	public int catCount(int parent) {
		int i = 0;

		for(CatalogPage page : Habbo.getCore().getCatalog().getPages().values())
		{
			if(page.ParentId == parent) {
				i++;
			}
		}

		return i;
	}
}
