package com.sulake.habbo.communication.messages.catalog;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.catalog.types.CatalogPage;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.utilities.Logger;
import com.sulake.sessions.types.Session;

public class OpenCatalogPageMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		int pageId = event.readInt();

		CatalogPage page =  Habbo.getCore().getCatalog().getPage(pageId);
		
		if(page != null) {
			//if(!page.Enabled)
			//	return;
			
			Composer msg = new Composer(Composers.OpenShopPageMessageComposer);
			
			msg.appendInt32(page.Id);
	
			if(page.getLayout().equals("frontpage")) {
				
				msg.appendString("frontpage3");
				msg.appendInt32(3);
				msg.appendString(page.Headline);
				msg.appendString(page.getTeaser());
				msg.appendString("");
				msg.appendInt32(11);
				msg.appendString(page.getSpecial());
				msg.appendString(page.getText1());
				msg.appendString("");
				msg.appendString(page.getText2());
				msg.appendString(page.getDetails());
				msg.appendString(page.getTeaser2());
				msg.appendString("Rares");
				msg.appendString("#FEFEFE");
				msg.appendString("#FEFEFE");
				msg.appendString("Click here for more info..");
				msg.appendString("magic.credits");
			} else {				
				msg.appendString(page.getLayout());
				msg.appendInt32(3);
				msg.appendString(page.Headline);
				msg.appendString(page.getTeaser());
				msg.appendString(page.getSpecial());
				msg.appendInt32(3);
				msg.appendString(page.getText1());
				msg.appendString(page.getDetails());
				msg.appendString(page.getTeaser2());				
			}
			
			if(!page.Template.equals("frontpage") && !page.Template.equals("club_buy")) {
				page.serialize(msg);
			} else {
				msg.appendInt32(0);
			}
			
			msg.appendInt32(-1);
			msg.appendBoolean(false);
	
			client.send(msg);
		} else {
			Logger.write("Could not find catalog " + pageId);
		}
	}
}