package com.sulake.habbo.communication.messages.navigator;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.categories.types.FlatCategory;
import com.sulake.sessions.types.Session;

public class LoadCategorysMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		Composer msg = new Composer(Composers.FlatCatsMessageComposer);
		
		msg.appendInt32(Habbo.getCore().getCategories().getCategories().size());
		
		for(FlatCategory cat : Habbo.getCore().getCategories().getCategories().values()) {
			cat.serialize(msg, 1); // 1 = rank
		}
		
		client.send(msg);
	}

}
