package com.sulake.habbo.communication.messages.rooms;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.sessions.types.Session;

public class LoadFirstRoomDataMessageEvent implements IMessageEvent {
	
	@Override
	public void parse(Session client, Event event) {
		int Id = event.readInt();
		String password = event.readString().toLowerCase();
		
		FlatInstance room = Habbo.getCore().getFlats().loadFlat(Id);
		
		if(client.getHabbo().getAvatar().inRoom && client.getHabbo().getAvatar().getCurrentFlat() != room) {
			client.getHabbo().getAvatar().getCurrentFlat().getClients().remove(client.getHabbo().Id);
			
			if(client.getHabbo().getAvatar().getCurrentFlat().getClients().size() == 0) {
				Habbo.getCore().getFlats().unloadFlat(client.getHabbo().getAvatar().getCurrentFlat().getData().Id);
			}
			
			client.getHabbo().getAvatar().inRoom = false;
		}
		
		client.getHabbo().getAvatar().loadingRoom = Id;
		
		if(room.getData().State == "locked") {
			
			if(room.clients.size() == 0) {
				Composer msg = new Composer(Composers.DoorBellNoPersonMessageComposer);
				client.send(msg);
			} else {
				// TODO send message to all users with rights
			}
		}
		
		if(room.getData().State == "password") {
			if(room.getData().password.toLowerCase() != password) {
				Composer msg = new Composer(Composers.RoomErrorMessageComposer);
				msg.appendInt32(-100002);
				client.send(msg);
				
				Composer outofroom = new Composer(Composers.OutOfRoomMessageComposer);
				client.send(outofroom);
			}
		}
		
		Composer msg = new Composer(Composers.InitialRoomInformationMessageComposer);
		msg.appendString(room.getData().Model.Id);
		msg.appendInt32(room.getData().Id);
		client.send(msg);
		
		if(room.getData().Wallpaper != "0.0") {
			Composer roomdecor = new Composer(Composers.RoomDecorationMessageComposer);
			roomdecor.appendString("wallpaper");
			roomdecor.appendString(room.getData().Wallpaper);
			client.send(roomdecor);
		}
		
		if(room.getData().Floor != "0.0") {
			Composer roomdecor = new Composer(Composers.RoomDecorationMessageComposer);
			roomdecor.appendString("floor");
			roomdecor.appendString(room.getData().Floor);
			client.send(roomdecor);
		}
		
		Composer roomdecor = new Composer(Composers.RoomDecorationMessageComposer);
		roomdecor.appendString("landscape");
		roomdecor.appendString(room.getData().Landscape);
		client.send(roomdecor);
		
		Composer score = new Composer(Composers.ScoreMeterMessageComposer);
		score.appendInt32(room.getData().Score);
		score.appendBoolean(true); // can vote
		client.send(score);

	}

}
