package com.sulake.habbo.communication.messages.rooms;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.sessions.types.Session;

public class LoadHeightMapMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		FlatInstance room = Habbo.getCore().getFlats().loadFlat(client.getHabbo().getAvatar().loadingRoom);
		
		if(room != null) {
			
			Composer map = new Composer(Composers.HeightMapMessageComposer);
			map.appendString(room.getData().Model.getMap());
			client.send(map);
			
			Composer relativeMap = new Composer(Composers.RelativeMapMessageComposer);
			relativeMap.appendString(room.getData().Model.getRelativeMap());
			client.send(relativeMap);
			
		} else {
			Composer outofroom = new Composer(Composers.OutOfRoomMessageComposer);
			client.send(outofroom);
		}
	}

}
