package com.sulake.habbo.communication.messages.rooms.actions;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.sessions.types.Session;

public class ApplyActionMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		int Id = event.readInt();
		
		FlatInstance room = client.getHabbo().getAvatar().getCurrentFlat();
		
		Composer msg = new Composer(Composers.ActionMessageComposer);
		msg.appendInt32(client.getHabbo().Id);
		msg.appendInt32(Id);
		
		room.send(msg);
		
		if(Id == 5) {
			Composer idle = new Composer(Composers.IdleStatusMessageComposer);
			idle.appendInt32(client.getHabbo().Id);
			idle.appendBoolean(true); // is asleep
			
			room.send(idle);
		}
	}
}
