package com.sulake.habbo.communication.messages.rooms.items;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.items.types.FlatItem;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.habbo.users.components.types.InventoryItem;
import com.sulake.sessions.types.Session;

public class AddFloorItemMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		try {
			String data = event.readString();
			String[] bits = data.split(" ");
			int Id = Integer.parseInt(bits[0]);
			
			FlatInstance room = client.getHabbo().getAvatar().getCurrentFlat();
			
			if(!room.getData().Owner.equals(client.getHabbo().Username))
				return;
			
			if(bits[1].startsWith(":")) {
				
			} else {
				InventoryItem item = client.getHabbo().getInventory().getFloorItems().get(Id);
				
				int X = Integer.parseInt(bits[1]);
				int Y = Integer.parseInt(bits[2]);
				int Rotation = Integer.parseInt(bits[3]);
				
				float Height = (float)room.getData().Model.getTileHeight(X, Y);
				
				// TODO: stacking
				
				Composer msg = new Composer(Composers.AddFloorItemToRoomMessageComposer);
				msg.appendInt32(Id);
				msg.appendInt32(item.getBaseItem().SpriteId);
				msg.appendInt32(X);
				msg.appendInt32(Y);
				msg.appendInt32(Rotation);
				msg.appendString(Float.toString(Height));
				msg.appendInt32(0);
				msg.appendInt32(0);
				msg.appendString("0");
				msg.appendInt32(-1);
				msg.appendInt32(item.getBaseItem().InteractionType.equals("default") ? 1 : 0);
				msg.appendInt32(room.getData().OwnerId);
				msg.appendString(room.getData().Owner);
				
				room.send(msg);
				
				// add floor item
				room.getItemManager().addItem(new FlatItem(item.Id, item.getBaseItem().Id, room.getData().Id, X, Y, 0, "", Rotation));
				
				// remove from inventory
				client.getHabbo().getInventory().removeItem(item, client);	
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

}
