package com.sulake.habbo.communication.messages.rooms.items.interactions;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.items.types.FlatItem;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.sessions.types.Session;

public class OpenDiceMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		int Id = event.readInt();
		
		FlatInstance room = client.getHabbo().getAvatar().getCurrentFlat();
		
		if(room.hasRights(client.getHabbo().Id)) {
			FlatItem item = room.getItemManager().getSingleItem(Id);
			String interactionType = item.getBaseItem().InteractionType;
			
			if(Habbo.getCore().getInteractions().isInteractable(interactionType)) {
				Habbo.getCore().getInteractions().get(interactionType).onInteract(false, client, item);
			}
		}
	}

}
