package com.sulake.habbo.communication.messages.types;

import java.io.IOException;
import java.nio.charset.Charset;

import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBufferOutputStream;
import org.jboss.netty.buffer.ChannelBuffers;

public class Composer
{
	private int Id;
	private ChannelBufferOutputStream bodystream;
	private ChannelBuffer body;

	public Composer() {
	}

	public Composer(int id) {
		this.Id = id;
		this.body = ChannelBuffers.dynamicBuffer();
		this.bodystream = new ChannelBufferOutputStream(body);

		try {
			this.bodystream.writeInt(0);
			this.bodystream.writeShort(id);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public Composer Initialize(int id)
	{
		this.Id = id;
		this.body = ChannelBuffers.dynamicBuffer();
		this.bodystream = new ChannelBufferOutputStream(body);

		try {
			this.bodystream.writeInt(0);
			this.bodystream.writeShort(id);

		} catch (Exception e) {
			e.printStackTrace();
		}
		return this;
	}

	public Composer appendString(Object obj)
	{
		try {
			bodystream.writeUTF(obj.toString());
		} catch (IOException e) {
		}
		return this;
	}

	public void appendInt32(Integer obj)
	{
		try {
			bodystream.writeInt(obj);
		} catch (IOException e) {
		}
	}

	public Composer appendInt32(Boolean obj)
	{
		try {
			bodystream.writeInt(obj ? 1 : 0);
		} catch (IOException e) {
		}
		return this;
	}

	public Composer appendShort(int obj)
	{
		try {
			bodystream.writeShort((short)obj);
		} catch (IOException e) {
		}
		return this;
	}

	public Composer appendBoolean(Boolean obj)
	{
		try {
			bodystream.writeBoolean(obj);
		} catch (IOException e) {
		}
		return this;
	}
	
	public String getBodyString()
	{
		ChannelBuffer bodeh = body.duplicate();

		bodeh.setInt(0, bodeh.writerIndex() - 4);

		String str = new String(bodeh.toString(Charset.defaultCharset()));

		String consoleText = str;

		for (int i = 0; i < 14; i++) { 
			consoleText = consoleText.replace(Character.toString((char)i), "[" + i + "]");
		}

		return consoleText;
	}

	public int getHeader() {

		return Id;
	}

	public ChannelBuffer get()
	{
		body.setInt(0, body.writerIndex() - 4);

		return this.body;
	}
}