package com.sulake.habbo.communication.messages.types;

import java.nio.charset.Charset;

import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBuffers;

public class Event {

	private Short Header;
	private ChannelBuffer Buffer;

	public ChannelBuffer getBuffer() {
		return Buffer;
	}

	public Event(Short id, ChannelBuffer buffer)
	{
		this.Header = id;
		this.Buffer = (buffer == null || buffer.readableBytes() == 0) ? ChannelBuffers.EMPTY_BUFFER : buffer;
	}

	public Event clone()
	{
		return new Event(this.Header, this.Buffer.duplicate());
	}

	public int readShort()
	{
		return Buffer.readShort();
	}

	public Integer readInt()
	{
		return Buffer.readInt();
	}

	public String readString()
	{
		int Length = this.readShort();
		byte[] Data = this.Buffer.readBytes((Length)).array();

		return new String(Data);
	}

	public Short getMessageHeader()
	{
		return Header;
	}

	public String getMessageBody()
	{
		String str = new String(Buffer.toString(Charset.defaultCharset()));

		String consoleText = str;

		for (int i = 0; i < 13; i++) { 
			consoleText = consoleText.replace(Character.toString((char)i), "[" + i + "]");
		}

		return consoleText;
	}

	public Short getHeader() {
		return this.Header;
	}
	
}
