package com.sulake.habbo.communication.messages.types;

import java.util.ArrayList;
import java.util.List;

import com.sulake.sessions.types.Session;

public class QueuedComposer {

	private List<Byte> bytes;
	private Session client;
	private byte[] builtPacket;
	
	public QueuedComposer(Session client) {
		this.bytes = new ArrayList<Byte>();
		this.client = client;
	}
	
	public void addComposer(Composer msg) {
		for(Byte b : msg.get().array()) {
			this.bytes.add(b);
		}
	}
	
	public byte[] buildPacket() {
		byte[] packet = new byte[this.bytes.size()];
		
		for(int i = 0; i < this.bytes.size(); i++) {
			this.builtPacket[i] = this.bytes.get(i);
		}
		
		return packet;
	}
	
	public void send() {
		this.client.getChannel().write(this.buildPacket());
	}
}
