package com.sulake.habbo.communication.messages.users;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.habbo.users.avatars.types.Avatar;
import com.sulake.habbo.users.components.types.Badge;
import com.sulake.sessions.types.Session;

public class GetUserBadgesMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		FlatInstance flat = client.getHabbo().getAvatar().getCurrentFlat();
		if(flat != null) {
			
			Avatar user = flat.getAvatarById(event.readInt());
			
			if(user != null) {
				Composer msg = new Composer(Composers.GetUserBadgesMessageComposer);
				msg.appendInt32(user.getHabbo().Id);
				msg.appendInt32(user.getHabbo().getBadgeComponent().getEquipedCount());
				
				for(Badge badge : user.getHabbo().getBadgeComponent().getBadges()) {
					if(badge.isEquiped()) {
						badge.serialize(msg);
					}
				}
				
				client.send(msg);
			}
		}
	}

}
