package com.sulake.habbo.communication.messages.users;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.habbo.users.components.types.InventoryItem;
import com.sulake.sessions.types.Session;

public class OpenInventoryMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		Composer floorItems = new Composer(Composers.InventoryMessageComposer);
		floorItems.appendString("S");
		floorItems.appendInt32(1);
		floorItems.appendInt32(1);
		floorItems.appendInt32(client.getHabbo().getInventory().getFloorItems().size());
		
		for(InventoryItem item : client.getHabbo().getInventory().getFloorItems().values()) {
			floorItems.appendInt32(item.getId());
			floorItems.appendString(item.getBaseItem().ItemType.toUpperCase());
			floorItems.appendInt32(item.getId());
			floorItems.appendInt32(item.getBaseItem().SpriteId);
			floorItems.appendInt32(1);
			floorItems.appendString("");
			floorItems.appendInt32(0);
			floorItems.appendBoolean(true); // allow recycle
			floorItems.appendBoolean(item.getBaseItem().CanTrade);
			floorItems.appendBoolean(true);
			floorItems.appendBoolean(true); // allow marketplace sell
			floorItems.appendInt32(-1);
			floorItems.appendString("");
			floorItems.appendInt32(0);
		}
		
		client.send(floorItems);
		
		
		Composer wallItems = new Composer(Composers.InventoryMessageComposer);
		wallItems.appendString("I");
		wallItems.appendInt32(1);
		wallItems.appendInt32(1);
		wallItems.appendInt32(client.getHabbo().getInventory().getWallItems().size());
		
		for(InventoryItem item : client.getHabbo().getInventory().getWallItems().values()) {
			wallItems.appendInt32(item.getId());
			wallItems.appendString(item.getBaseItem().ItemType.toUpperCase());
			wallItems.appendInt32(item.getId());
			wallItems.appendInt32(item.getBaseItem().SpriteId);
			
			if(item.getBaseItem().ItemName.contains("floor") || item.getBaseItem().ItemName.contains("a2")) {
				wallItems.appendInt32(3);
			}
			else if(item.getBaseItem().ItemName.contains("wall")) {
				wallItems.appendInt32(2);
			}
			else if(item.getBaseItem().ItemName.contains("land")) {
				wallItems.appendInt32(4);
			}
			else {
				wallItems.appendInt32(1);
			}
			
			wallItems.appendInt32(0);
			
			if((item.getBaseItem().ItemName.contains("floor") || item.getBaseItem().ItemName.contains("wall")) && item.getBaseItem().ItemName.split("_")[2] != null) {
				wallItems.appendString(item.getBaseItem().ItemName.split("_")[2]);
			} else {
				wallItems.appendString("");
			}
			
			wallItems.appendBoolean(true); // allow recycle
			wallItems.appendBoolean(item.getBaseItem().CanTrade);
			wallItems.appendBoolean(true); // inv stack
			wallItems.appendBoolean(true); // allow marketplace sell
			wallItems.appendInt32(-1);	
		}
		
		client.send(wallItems);
		
		
	}

}
