package com.sulake.habbo.communication.messages.users;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.communication.messages.types.Event;
import com.sulake.habbo.communication.messages.types.IMessageEvent;
import com.sulake.sessions.types.Session;

public class UserInformationMessageEvent implements IMessageEvent {

	@Override
	public void parse(Session client, Event event) {
		
		Composer composer = new Composer(Composers.HabboInfomationMessageComposer);
		
		composer.appendInt32(client.getHabbo().getId());
		composer.appendString(client.getHabbo().getUsername());
		composer.appendString(client.getHabbo().getFigure());
		composer.appendString(client.getHabbo().getGender().toUpperCase()); // gender toupper
		composer.appendString(client.getHabbo().getMotto().toUpperCase()); // motto
		composer.appendString("John Doe"); // "Real name"
		composer.appendBoolean(false);
		composer.appendInt32(100); // respects
		composer.appendInt32(0); // respect to give away
		composer.appendInt32(0); // pet respects
		composer.appendBoolean(true);
		composer.appendString("12/12/2012 23:23"); // last online
		composer.appendBoolean(false); // can change name
		composer.appendBoolean(false);
		
		client.send(composer);
		
		Composer msg = new Composer(Composers.AllowancesMessageComposer);
		msg.appendInt32(7);
        msg.appendString("VOTE_IN_COMPETITIONS");
        msg.appendBoolean(true);
        msg.appendString("");
        msg.appendString("TRADE");
        msg.appendBoolean(true);
        msg.appendString("");
        msg.appendString("CITIZEN");
        msg.appendBoolean(true);
        msg.appendString("");
        msg.appendString("SAFE_CHAT");
        msg.appendBoolean(true);
        msg.appendString("");
        msg.appendString("FULL_CHAT");
        msg.appendBoolean(true);
        msg.appendString("");
        msg.appendString("CALL_ON_HELPERS");
        msg.appendBoolean(true);
        msg.appendString("");
        msg.appendString("USE_GUIDE_TOOL");
        msg.appendBoolean(false);
        msg.appendString("requirement.unfulfilled.helper_level_4");
        msg.appendString("JUDGE_CHAT_REVIEWS");
        msg.appendBoolean(false);
        msg.appendString("requirement.unfulfilled.helper_level_6");
        
        client.send(msg);
	}
}
