package com.sulake.habbo.communication.remote;

import java.net.InetSocketAddress;
import java.util.concurrent.Executors;

import org.jboss.netty.bootstrap.ServerBootstrap;
import org.jboss.netty.channel.ChannelPipeline;
import org.jboss.netty.channel.socket.nio.NioServerSocketChannelFactory;
import org.jboss.netty.handler.codec.http.HttpChunkAggregator;
import org.jboss.netty.handler.codec.http.HttpRequestDecoder;
import org.jboss.netty.handler.codec.http.HttpResponseEncoder;

import com.sulake.sessions.SessionManager;

public class RemoteServerManager {

	private NioServerSocketChannelFactory channelFactory;
	private ServerBootstrap serverBootstrap;

	public SessionManager sessionManager;
	public RemoteRequestHandler requests;

	public RemoteServerManager(String ip, int port) {
		
		this.channelFactory = new NioServerSocketChannelFactory(
				Executors.newCachedThreadPool(),
				Executors.newCachedThreadPool()
		);
		
		this.serverBootstrap = new ServerBootstrap(this.channelFactory);

		ChannelPipeline pipeline = serverBootstrap.getPipeline();
		pipeline.addLast("decoder", new HttpRequestDecoder());
		pipeline.addLast("aggregator", new HttpChunkAggregator(65536));
		pipeline.addLast("encoder", new HttpResponseEncoder());
		pipeline.addLast("handler", new RemoteServerHandler());
		
		this.requests = new RemoteRequestHandler();
		
		this.serverBootstrap.bind(new InetSocketAddress(ip, port));
	}
	
	public RemoteRequestHandler getRequests() {
		return this.requests;
	}
}
