package com.sulake.habbo.communication.remote.requests.rooms;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.remote.requests.IWebRequest;
import com.sulake.habbo.communication.remote.utils.JsonObject;
import com.sulake.habbo.flats.types.FlatInstance;
import com.sulake.sessions.types.Session;

public class GetActiveRooms implements IWebRequest {

	@Override
	public JsonObject parse(String[] params) {
		JsonObject data = new JsonObject();
		data.createArray("rooms");
		
		data.put("status", "complete");

		for(FlatInstance room : Habbo.getCore().getFlats().getFlats().values()) {
			JsonObject r = new JsonObject();
			r.createArray("users");

			r.put("id", String.valueOf(room.getData().Id));
			r.put("name", room.getData().Name);
			r.put("description", room.getData().Description);
			r.put("owner", room.getData().Owner);

			for(Session user : room.getClients().values()) {
				JsonObject u = new JsonObject();

				u.put("id", String.valueOf(user.getHabbo().Id));
				u.put("username", String.valueOf(user.getHabbo().Username));
				u.put("rank", String.valueOf(user.getHabbo().getRank().Name));
				u.put("figure", String.valueOf(user.getHabbo().Figure));
				
				r.putIntoArray("users", u);
			}	
			
			data.putIntoArray("rooms", r);
		}
		
		return data;
		
	}

}
