package com.sulake.habbo.communication.remote.utils;

import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.utilities.Logger;

public class JsonObject {
	private Map<String, String> data;
	private Map<String, String> arrays;
	
	public JsonObject() {
		this.data = new HashMap<String, String>();
		this.arrays = new HashMap<String, String>();
	}
	
	public void put(String key, String value) {
		this.getData().put(key, value.replace("\"", "\""));
	}
	
	public void createArray(String name) {
		this.getArrays().put(name, "");
	}
	
	public void putIntoArray(String array, JsonObject o) {
		for(Map.Entry<String, String> entry : this.getArrays().entrySet()) {
			if(entry.getKey().equals(array)) {
				entry.setValue(o.get());
			}
		}
	}
	
	public String get() {
		int i = 0;
		Map<String, String> entries = new HashMap<String, String>();
		
		for(Map.Entry<String, String> d : this.getArrays().entrySet()) {
			entries.put(d.getKey(), d.getValue());
		}
		
		for(Map.Entry<String, String> d : this.getData().entrySet()) {
			entries.put(d.getKey(), d.getValue());
		}
		
		String product = "{ ";
		for(Map.Entry<String, String> data : this.getData().entrySet()) {
			i++;
			product += "\"" + data.getKey() + "\":\"" + data.getValue() + "\"" + (i < entries.size() ? "," : "");
		}
		
		if(this.getArrays().entrySet().size() > 0) {
			for(Map.Entry<String, String> d : this.getArrays().entrySet()) {
				i++;
				product += "\"" + d.getKey() + "\":[" + d.getValue() + "]" + (i < entries.size() ? "," : "");
				Logger.write(i + "");
			}
		}
		
		this.getData().clear();
		this.getArrays().clear();
		return product + " }";
	}

	private Map<String, String> getData() {
		return this.data;
	}
	
	private Map<String, String> getArrays() {
		return this.arrays;
	}
}
