package com.sulake.habbo.configuration;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class Config {
	
	public String file;
	public Properties props;
	
	public Config() { }
	public Config(String filename) {
		
		this.file = filename;
		
		this.loadProperties();
	}
	
	public void loadProperties() {
		InputStream inputStream = new Config().getClass().getResourceAsStream(this.file);  
		
		this.props = new Properties();
		try {
			
			this.props.load(inputStream);
			
		} catch (IOException e) {
			
			e.printStackTrace();
			
		}
	}
	
	public Properties getProperties() {
		return this.props;
	}
	
}
