package com.sulake.habbo.currencies;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.currencies.types.Currency;
import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.utilities.Logger;

public class CurrencyManager {

	public static Map<Integer, Currency> currencies;
	
	public static void loadAll(DatabaseManager db) {
		CurrencyManager.currencies = new HashMap<Integer, Currency>();
		
		ResultSet result = db.readTable("SELECT * FROM currencies WHERE enabled = '1'");
		
		try {
			while(result.next()) {
				Currency c = new Currency(result.getInt("id"), (result.getString("premium") == "1"), result.getString("name"));
				CurrencyManager.getCurrencies().put(c.getId(), c);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		Logger.write("Loaded " + CurrencyManager.getCurrencies().size() + " currencies");
	}

	public static Currency get(int currency_id) {
		
		if(CurrencyManager.getCurrencies().containsKey(currency_id)) {
			
			return CurrencyManager.getCurrencies().get(currency_id);
			
		} else {
			return null;
		}
	}

	public static Map<Integer, Currency> getCurrencies() {
		return CurrencyManager.currencies;
	}
	
}