package com.sulake.habbo.flats.actions;

import java.util.List;

import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.flats.actions.pathfinder.Coord;
import com.sulake.habbo.flats.actions.pathfinder.Pathfinder;
import com.sulake.habbo.flats.actions.pathfinder.Rotation;
import com.sulake.habbo.flats.items.types.FlatItem;
import com.sulake.sessions.types.Session;

/*
 * @author Quackster (github.com/quackster)
 */

public class UserWalker implements Runnable
{
	private Session mSession;
	public Boolean Stop;
	public boolean stopRequested = false;

	public UserWalker(Session mSession) {
		this.mSession = mSession;
		this.Stop = false;
	}

	@Override
	public void run()
	{
		try {
			/*
			 * Calculate the path
			 */
			Pathfinder Path = new Pathfinder(mSession);

			List<Coord> ListOfCoords = Path.PathCollection();

			mSession.getHabbo().getAvatar().isWalking = true;
			for (Coord Following : ListOfCoords)
			{
				if(stopRequested) {
					this.Stop = true;
				}
				
				if (!Stop)
				{
					try
					{
						int X = Following.X;
						int Y = Following.Y;
						mSession.getHabbo().getAvatar().Rotation = Rotation.Calculate(mSession.getHabbo().getAvatar().X, mSession.getHabbo().getAvatar().Y, X, Y);
						mSession.getHabbo().getAvatar().Height = mSession.getHabbo().getAvatar().getCurrentFlat().getData().Model.getTileHeight(X, Y); // tile height?
						
						mSession.getHabbo().getAvatar().addStatus("mv", X +","+ Y +"," + Double.toString(mSession.getHabbo().getAvatar().getCurrentFlat().getData().Model.getTileHeight(X, Y)));
						mSession.getHabbo().getAvatar().sendStatus();	
						
						mSession.getHabbo().getAvatar().X = X;
						mSession.getHabbo().getAvatar().Y = Y;
						mSession.getHabbo().getAvatar().selectedSquare = true;
						Thread.sleep(500);

						if (X == mSession.getHabbo().getAvatar().getCurrentFlat().getData().Model.DoorX && Y == mSession.getHabbo().getAvatar().getCurrentFlat().getData().Model.DoorY)
						{
							Composer outofroom = new Composer(Composers.OutOfRoomMessageComposer);
							mSession.send(outofroom);
							
							mSession.getHabbo().getAvatar().getCurrentFlat().getClients().remove(mSession.getHabbo().Id);
						}
						
						List<FlatItem> Items = mSession.getHabbo().getAvatar().getCurrentFlat().getItemManager().getItemsByCoords(X, Y);

						for (FlatItem Item : Items)
						{
							if (Item.getBaseItem().CanSit)
							{
								mSession.getHabbo().getAvatar().isSitting = true;
								mSession.getHabbo().getAvatar().Rotation = Item.Rotation;
								mSession.getHabbo().getAvatar().addStatus("sit", Double.toString(Item.getBaseItem().StackHeight));
								
								mSession.getHabbo().getAvatar().sendStatus();
							}
							else
							{
								BlankTile();
							}
						}
					}
					catch (Exception e)
					{
						BlankTile();
					}
				}
				else
				{
					Thread.sleep(0);
				}
			}
			
			mSession.getHabbo().getAvatar().isWalking = false;
			BlankTile();

		} catch (Exception e) {
			/*mSession.getRoomUser().mUserWalk = new Thread(new UserWalker(mSession));
			mSession.getRoomUser().mUserWalk.start();*/
		}	
	}
	public void BlankTile()
	{
		mSession.getHabbo().getAvatar().selectedSquare = false;
		mSession.getHabbo().getAvatar().isSitting = false;
		mSession.getHabbo().getAvatar().getStatuses().remove("mv");
		
		mSession.getHabbo().getAvatar().sendStatus();
		
	}
}
