package com.sulake.habbo.flats.actions.pathfinder;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import com.sulake.habbo.flats.models.types.FlatTileState;
import com.sulake.sessions.types.Session;

public class Pathfinder
{
	private Point[] AvaliablePoints;

	private int MapSizeX = 0;
	private int MapSizeY = 0;

	private FlatTileState[][] Squares;

	private Session User;
	public int GoX;
	public int GoY;
	public Pathfinder(Session session)
	{
		AvaliablePoints = new Point[]
				{ 
				new Point(0, -1),
				new Point(0, 1),
				new Point(1, 0),
				new Point(-1, 0),
				new Point(1, -1),
				new Point(-1, 1),
				new Point(1, 1),
				new Point(-1, -1)
				};

		MapSizeX = session.getHabbo().getAvatar().getCurrentFlat().getData().Model.MapSizeX;
		MapSizeY = session.getHabbo().getAvatar().getCurrentFlat().getData().Model.MapSizeY;
		Squares = session.getHabbo().getAvatar().getCurrentFlat().getData().Model.getTileState();

		this.User = session;
	}

	public List<Coord> PathCollection()
	{
		List<Coord> CoordSquares = new ArrayList<Coord>();

		int UserX = User.getHabbo().getAvatar().X;
		int UserY = User.getHabbo().getAvatar().Y;

		GoX = User.getHabbo().getAvatar().GoalX;
		GoY = User.getHabbo().getAvatar().GoalY;

		Coord LastCoord = new Coord(-200, -200);
		int Trys = 0;

		while(true)
		{
			Trys++;
			int StepsToWalk = 10000;
			for(Point MovePoint: AvaliablePoints)
			{
				int newX = MovePoint.x + UserX;
				int newY = MovePoint.y + UserY;

				if (newX >= 0 && newY >= 0 && MapSizeX > newX && MapSizeY > newY && Squares[newX][newY] == FlatTileState.VALID && !User.getHabbo().getAvatar().getCurrentFlat().checkUserCoordinates(newX,  newY))
				{
					Coord pCoord = new Coord(newX, newY);
					pCoord.PositionDistance = DistanceBetween(newX, newY, GoX, GoY);
					pCoord.ReversedPositionDistance = DistanceBetween(GoX, GoY, newX, newY);

					if(StepsToWalk > pCoord.PositionDistance)
					{
						StepsToWalk = pCoord.PositionDistance;
						LastCoord = pCoord;
					}
				}
			}
			if(Trys >= 200)
				return null;

			else if(LastCoord.X == -200 && LastCoord.Y == -200)
				return null;

			UserX = LastCoord.X;
			UserY = LastCoord.Y;
			CoordSquares.add(LastCoord);

			if(UserX == GoX && UserY == GoY)
				break;
		}
		return CoordSquares;
	}
	/*public Boolean CheckFurniCoordinates(int X, int Y)
	{
		for (FloorItem Item : User.getRoomUser().getCurrentRoom().getItemListByCoords(X, Y))
		{
			if (Item == null || (Item.GetBaseItem().InteractionType.equals("gate") && Item.ExtraData.equals("1")) || (Item.GetBaseItem().CanSit || Item.GetBaseItem().IsWalkable))
			{
				return false;
			}
			else if (Item.X == X && Item.Y == Y && !Item.GetBaseItem().CanSit)
			{
				return true;
			}
			else
			{
				List<AffectedTile> AffectedTiles = AffectedTile.GetAffectedTiles(Item.GetBaseItem().Length, Item.GetBaseItem().Width, Item.X, Item.Y, Item.Rotation);

				for (AffectedTile Tile : AffectedTiles)
				{
					if ((Item.GetBaseItem().InteractionType.equals("gate") && Item.ExtraData.equals("1"))  || (Item.GetBaseItem().CanSit || Item.GetBaseItem().IsWalkable))
					{	
						return false;
					}
					else if (X == Tile.X && Y == Tile.Y && !Item.GetBaseItem().CanSit)
					{
						return true;
					}
				}
			}
		}
		
		return false;
	}*/
	private int DistanceBetween(int currentX, int currentY, int goX, int goY)
	{
		return Math.abs(currentX - goX) + Math.abs(currentY - goY);
	}

}