package com.sulake.habbo.flats.categories;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.flats.categories.types.FlatCategory;
import com.sulake.habbo.utilities.Logger;

public class CategoryManager {

	public Map<Integer, FlatCategory> categories;
	
	public void loadAll(DatabaseManager db) {
		this.categories = new HashMap<Integer, FlatCategory>();

		ResultSet result = db.readTable("SELECT * FROM flat_categories");
		
		try {
			while(result.next()) {
				try {
					
					FlatCategory c = new FlatCategory(result.getInt("id"), result.getString("name"), result.getInt("min_rank"), (result.getString("can_trade") == "1") ? true : false);
					this.getCategories().put(c.Id, c);
					
				} catch(Exception e) {
					e.printStackTrace();
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		Logger.write("Loaded " + getCategories().size()  + " flat categories");
	}

	public Map<Integer, FlatCategory> getCategories() {
		return this.categories;
	}
		
}
