package com.sulake.habbo.flats.items;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.flats.items.types.FlatItem;
import com.sulake.habbo.flats.types.FlatInstance;

public class ItemManager {
	public Map<Integer, FlatItem> items;
	public FlatInstance room;
	
	public ItemManager(FlatInstance room) {
		this.items = new HashMap<Integer, FlatItem>();
		this.room = room;
		
		loadItems();
	}
	
	public void loadItems() {
		ResultSet row = Habbo.getCore().getDatabase().readTable("SELECT * FROM `flat_items` WHERE `room_id` = " + this.getRoom().getData().Id + ";");
		if(row != null) {
			try {
				while(row.next()) {
					FlatItem i = new FlatItem(row.getInt("id"), row.getInt("definition_id"), row.getInt("room_id"), row.getInt("x"), row.getInt("y"), row.getInt("wall_position"), row.getString("extra_data"), row.getInt("rotation"));
					this.getItems().put(i.Id, i);
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	
	public void addItem(FlatItem item) {
		try{
			this.getItems().put(item.Id, item);
			
			
			PreparedStatement query = Habbo.getCore().getDatabase().queryParams("INSERT into `flat_items` (`room_id`, `definition_id`, `x`, `y`, `wall_position`, `extra_data`) VALUES(?, ?, ?, ?, ?, ?);");
			query.setInt(1, this.getRoom().getData().Id);
			query.setInt(2, item.ItemId);
			query.setInt(3, item.X);
			query.setInt(4, item.Y);
			query.setInt(5, item.WallPos);
			query.setString(6, item.ExtraData);
			
			query.executeUpdate();
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public void dispose() {
		this.getItems().clear();
		this.items = null;
		this.room = null;
	}
	
	public FlatItem getSingleItem(int Id) {
		if(this.getItems().containsKey(Id)) {
			return this.getItems().get(Id);
		} else {
			return null;
		}
	}
	
	public List<FlatItem> getItemsByCoords(int X, int Y) {
		List<FlatItem> items = new ArrayList<FlatItem>();
		
		for(FlatItem item : this.getItems().values()) {

			if(item.X == X && item.Y == Y) {
				items.add(item);
			}
		}
		
		return items;
	}
	
	public Map<Integer, FlatItem> getItems() {
		return this.items;
	}
	
	public FlatInstance getRoom() {
		return this.room;
	}
}
