package com.sulake.habbo.flats.items.definitions;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.flats.items.definitions.types.ItemDefinition;
import com.sulake.habbo.utilities.Logger;

public class ItemDefinitionManager {
	public Map<Integer, ItemDefinition> items;
	
	public ItemDefinitionManager() {
		this.items = new HashMap<Integer, ItemDefinition>();
	}
	
	public void loadAll(DatabaseManager databaseManager) {
		ResultSet row = databaseManager.readTable("SELECT * FROM `item_definitions`");
		if(row != null) {
			try {
				while(row.next()) {
					ItemDefinition i = new ItemDefinition(row.getInt("id"), row.getInt("sprite_id"),  row.getString("type"), row.getString("public_name"), row.getString("item_name"), row.getInt("width"), 
							row.getInt("length"), row.getDouble("stack_height"), ((row.getString("can_stack").equals("1")) ? true : false), ((row.getString("can_sit").equals("1")) ? true : false),
							((row.getString("is_walkable").equals("1")) ? true : false), ((row.getString("allow_trade").equals("1")) ? true : false), row.getString("interaction_type"), row.getInt("vending_ids"));
					
					this.getItems().put(i.Id, i);
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
		Logger.write("Loaded " + this.getItems().size() + " item definitions");
	}
	
	public ItemDefinition getDefinition(int Id) {
		if(this.getItems().containsKey(Id)) {
			return this.getItems().get(Id);
		} else {
			return null;
		}
	}
	
	public Map<Integer, ItemDefinition> getItems() {
		return this.items;
	}
}
