package com.sulake.habbo.flats.items.interactions;

import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.flats.items.interactions.types.DiceInteraction;

public class InteractionManager {
	public Map<String, Interaction> interactions;
	
	public InteractionManager() {
		this.interactions = new HashMap<String, Interaction>();
		this.addInteractions();
	}
	
	public void addInteractions() {
		this.getInteractions().put("dice", new DiceInteraction());
	}
	
	public boolean isInteractable(String interactionType) {
		return (this.getInteractions().containsKey(interactionType) ? true : false);
	}
		
	public Interaction get(String interactionType) {
		return this.getInteractions().get(interactionType);
	}
	
	public Map<String, Interaction> getInteractions() {
		return this.interactions;
	}
}
