package com.sulake.habbo.flats.items.types;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.flats.items.definitions.types.ItemDefinition;
import com.sulake.sessions.types.Session;

public class FlatItem {
	public int Id;
	public int ItemId;
	public int RoomId;
	public int X;
	public int Y;
	public int Rotation;
	public int WallPos;
	public String ExtraData;
	public boolean isWallItem;
	public float Height;
	
	public FlatItem(int id, int itemId, int roomId, int x, int y, int wallPos, String extraData, int rotation) {
		Id = id;
		ItemId = itemId;
		RoomId = roomId;
		X = x;
		Y = y;
		WallPos = wallPos;
		ExtraData = extraData;
		Rotation = rotation;
		
		isWallItem = false;
	}
	
	public void save() {
		PreparedStatement query = Habbo.getCore().getDatabase().queryParams("UPDATE flat_items SET x = ?, y = ?, wall_position = ? AND extra_data = ? WHERE id = ?");
		try {
			query.setInt(1, this.X);
			query.setInt(2, this.Y);
			query.setInt(3, this.WallPos);
			query.setString(4, this.ExtraData);
			query.setInt(5, this.Id);
			
			query.execute();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public ItemDefinition getBaseItem() {
		return Habbo.getCore().getItems().getDefinition(this.ItemId);
	}
	
	public void serialize(Composer msg) {
		msg.appendInt32(Id);
		msg.appendInt32(this.getBaseItem().SpriteId);
		msg.appendInt32(X);
		msg.appendInt32(Y);
		msg.appendInt32(Rotation);
		msg.appendString("0.0"); // height
		msg.appendInt32(0);
		msg.appendInt32(0);
		msg.appendString(ExtraData);
		msg.appendInt32(-1);
		msg.appendInt32(this.getBaseItem().InteractionType.equals("default") ? 1 : 0);
	}
	
	public void sendExtraData(Session client) {
		Composer msg = new Composer(Composers.UpdateFloorItemExtraDataMessageComposer);
		msg.appendString(Id);
		msg.appendInt32(0);
		msg.appendString(ExtraData);
		
		client.getHabbo().getAvatar().getCurrentFlat().send(msg);
	}

}
