package com.sulake.habbo.flats.models;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.flats.models.types.FlatModel;
import com.sulake.habbo.utilities.Logger;

public class ModelManager {

	public Map<String, FlatModel> models;
	
	public void loadAll(DatabaseManager db) {
		this.models = new HashMap<String, FlatModel>();

		ResultSet result = db.readTable("SELECT * FROM flat_models");
		
		try {
			while(result.next()) {
				try {
					FlatModel m = new FlatModel(result.getString("id"), result.getInt("door_dir"), result.getInt("door_x"), result.getInt("door_y"), result.getDouble("door_z"), result.getString("heightmap"));
					this.getModels().put(m.Id, m);
					
				} catch(Exception e) {
					e.printStackTrace();
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		Logger.write("Loaded " + getModels().size()  + " flat models");
	}
	
	public FlatModel get(String Id) {
		return getModels().get(Id);
	}
	
	public Map<String, FlatModel> getModels() {
		return this.models;
	}
		
}
