package com.sulake.habbo.flats.models.types;

public class FlatModel {

	public String Id;
    public int DoorOrientation;
    public int DoorX;
    public int DoorY;
    public double DoorZ;
    
    public String Heightmap;
	private String RelativeMap = "";
	private String Map = "";
    public int MapSizeX;
    public int MapSizeY;

	private int MapSize;
	private int OPEN = 0;
	private int CLOSED = 1;
	private int[][] Squares;
	private double[][] SquareHeight;
	private FlatTileState[][] SquareState;

	public String getName() {
		return Id;
	}
	public String getMap() {
		return Map;
	}
	public String getRelativeMap() {
		return RelativeMap;
	}
	public int getDoorX() {
		return DoorX;
	}
	public int getDoorY() {
		return DoorY;
	}
	public double getDoorZ() {
		return DoorZ;
	}
	public int getDoorRot() {
		return DoorOrientation;
	}
	public int getMapSizeX() {
		return MapSizeX;
	}
	public int getMapSizeY() {
		return MapSizeY;
	}
	public int getMapSize() {
		return MapSize;
	}

	public FlatTileState[][] getTileState() {
		return SquareState;
	}
	public double[][] getSquareHeight() {
		return SquareHeight;
	}
	public int[][] getSqState() {
		return Squares;
	}
    
	public FlatModel(String id, int doorOrientation, int doorX, int doorY, double doorZ, String heightmap) {
		Id = id;
		DoorOrientation = doorOrientation;
		DoorX = doorX;
		DoorY = doorY;
		DoorZ = doorZ;
		Heightmap = heightmap;
		
		/**
		 * @author Nillus
		 */

		String[] Temporary = Heightmap.split(Character.toString((char)13));

		this.MapSizeX = Temporary[0].length();
		this.MapSizeY = Temporary.length;
		this.Squares = new int[MapSizeX][MapSizeY];
		this.SquareHeight = new double[MapSizeX][MapSizeY];
		this.SquareState = new FlatTileState[MapSizeX][MapSizeY];


		for (int y = 0; y < MapSizeY; y++)
		{
			if (y > 0)
			{
				Temporary[y] = Temporary[y].substring(1);
			}

			for (int x = 0; x < MapSizeX; x++)
			{
				String Square = Temporary[y].substring(x,x + 1).trim().toLowerCase();

				if (Square.equals("x"))
				{
					SquareState[x][y] = FlatTileState.INVALID;
					Squares[x][y] = CLOSED;
				}
				else if(isNumeric(Square))
				{
					SquareState[x][y] = FlatTileState.VALID;
					Squares[x][y] = OPEN;
					SquareHeight[x][y] = Double.parseDouble(Square);
					MapSize++;
				}

				if (this.DoorX == x && this.DoorY == y)
				{
					SquareState[x][y] = FlatTileState.VALID;
					RelativeMap += (int)DoorZ + "";
				}
				else
				{
					if(Square.isEmpty() || Square == null)
					{
						continue;
					}
					RelativeMap += Square;
				}
			}
			RelativeMap += (char)13;
		}

		for(String MapLine: Heightmap.split("\r\n"))
		{
			if(MapLine.isEmpty() || MapLine == null)
			{
				continue;
			}
			
			Map += MapLine + (char)13;
		}
	}    
	
	private boolean isNumeric(String Input)
	{
		try
		{
			Integer.parseInt(Input);
			return true;
		}
		catch (Exception e)
		{
			return false;
		}
	}
	
	public double getTileHeight(int X, int Y) {
		return this.SquareHeight[X][Y];
	}

}
