package com.sulake.habbo.flats.types;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.flats.models.types.FlatModel;
import com.sulake.habbo.users.dao.UserDao;
import com.sulake.habbo.users.types.User;

public class FlatData {

	public int Id;
	public String Owner;
	public int OwnerId;
	public String Name;
	public String Description;
	public String State;
	public int Users;
	public int MaxUsers;
	public int Category;
	public int Score;
	public int GroupId;
	public String[] Tags;
	public String Wallpaper;
	public String Floor;
	public String Landscape;
	
	public FlatModel Model;
	
	public String password;

	public FlatData(int id, String name, String description, String owner, String state, int users, int maxUsers, int category, int score, int groupId, String tags, String wallpaper, String floor, String landscape, String model) {
		Id = id;
		Name = name;
		Description = description;
		Owner = owner;
		Users = users;
		MaxUsers = maxUsers;
		Category = category;
		Score = score;
		GroupId = groupId;
		Wallpaper = wallpaper;
		Floor = floor;
		Landscape = landscape;
		State = state;
		
		Tags = tags.split(",");
		
		Model = Habbo.getCore().getModels().get(model);
		
		User user;
		if(Habbo.getCore().getSessions().getClientByHabbo(this.Owner) != null) {
			user = Habbo.getCore().getSessions().getClientByHabbo(this.Owner).getHabbo();
		} else {
			user = UserDao.loadUserByUsername(this.Owner);
		}
		
		OwnerId = user.Id;
	}
	
	public void serialize(Composer msg) {	
		msg.appendInt32(this.Id);
		msg.appendString(this.Name);
		msg.appendBoolean(true);
		msg.appendInt32(this.OwnerId); // owner id
		msg.appendString(this.Owner);
		msg.appendInt32(0); // state
		
		if(Habbo.getCore().getFlats().loadFlat(Id) != null) {
			FlatInstance temp = Habbo.getCore().getFlats().loadFlat(Id);
			msg.appendInt32(temp.getClients().size());
		} else {
			msg.appendInt32(this.Users);
		}
		
		msg.appendInt32(this.MaxUsers);
		msg.appendString(this.Description);
		msg.appendInt32((this.Category == 3) ? 2 : 0);
		msg.appendInt32(0); // can trade
		msg.appendInt32(this.Score);
		msg.appendInt32(0);
		msg.appendInt32(this.Category);
		msg.appendInt32(0);
		msg.appendInt32(0);
		
		msg.appendString("");

		msg.appendInt32(this.Tags.length);
		
		for(String str : this.Tags) {
			msg.appendString(str);
		}
		
		msg.appendInt32(0);
		msg.appendInt32(0);
		msg.appendInt32(0);
		msg.appendBoolean(true);
		msg.appendBoolean(true);
		msg.appendInt32(0);
		msg.appendInt32(0);
	}
	
	public void updateCount() {
		// TODO: update count of users in room in db
	}
	
}
