package com.sulake.habbo.game.encryption;

import java.math.BigInteger;

public class HabboCrypto {

	private RSA RSA;
	
	public Boolean Initialized;
	
	public RC4 RC4;
	
	public DiffieHellman dHell;
	
	public HabboCrypto(BigInteger _n, BigInteger _e, BigInteger _d)
	{
	    this.RSA = new RSA(_n, _e, _d, BigInteger.valueOf(0), BigInteger.valueOf(0), BigInteger.valueOf(0), BigInteger.valueOf(0), BigInteger.valueOf(0));
	    this.RC4 = new RC4();
	    this.dHell = new DiffieHellman(200);
	    this.Initialized = false;
	}
	
	public Boolean InitializeRC4(String ctext)
	{
	    try
	    {
	        String publickey = this.RSA.Decrypt(ctext);
	        
	        this.dHell.GenerateSharedKey(publickey.replace(Character.toString((char)0), ""));
	
	        this.RC4.Init(this.dHell.SharedKey.toString().getBytes());
	
	        this.Initialized = true;
	
	        return true;
	    }
	    catch (Exception e)
	    {
	    	e.printStackTrace();
	        return false;
	    }
	}
	
	public String getSharedKey() {
		return dHell.SharedKey.toString();
	}
	
	public String getPublicKey() {
		return dHell.PublicKey.toString();
	}
	
	public String getPrivateKey() {
		return dHell.PrivateKey.toString();
	}
}