package com.sulake.habbo.settings;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.settings.types.ServerSetting;
import com.sulake.habbo.utilities.Logger;

public class ServerSettings {

	public static Map<String, ServerSetting> settings;
	protected DatabaseManager db;
	
	public ServerSettings(DatabaseManager db) {
		this.db = db;
		settings = new HashMap<String, ServerSetting>();
	}
	
	public void loadAll() {
		
		ResultSet settings = db.readTable("SELECT * FROM `server_settings`");
		
		try {
			while(settings.next()) {
				
				ServerSetting ss = new ServerSetting(settings.getString("skey"), settings.getString("sval"));
				
				ServerSettings.settings.put(settings.getString("skey"), ss);
				
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		Logger.write("Loaded " + ServerSettings.settings.size() + " server settings");
		
	}
	
	public void saveAll() {
		for(ServerSetting setting : settings.values()) {
			this.save(setting);
		}
	}
	
	public void save(ServerSetting serverSetting) {
		this.db.executeQuery("UPDATE `server_settings` SET `sval` = '" + serverSetting.value + "' WHERE `skey` = '" + serverSetting.key + "' LIMIT 1;");
	}
	
	public static ServerSetting get(String key) {
		if(settings.containsKey(key)) {
			return settings.get(key);
		} else {
			return null;
		}
	}
	
}
