package com.sulake.habbo.users.avatars.chat;

import java.util.HashMap;
import java.util.Map;

public class AvatarChat {
    public Map<String, ChatEmotion> emotions;
	public AvatarChat() {
		emotions = new HashMap<String, ChatEmotion>();
		
		emotions.put(":)", ChatEmotion.Smile);
		emotions.put(";)", ChatEmotion.Smile);
		emotions.put(":]", ChatEmotion.Smile);
		emotions.put(";]", ChatEmotion.Smile);
		emotions.put("=)", ChatEmotion.Smile);
		emotions.put("=]", ChatEmotion.Smile);
		emotions.put(":-)", ChatEmotion.Smile);
		
		emotions.put(">:(", ChatEmotion.Angry);
		emotions.put(">:[", ChatEmotion.Angry);
		emotions.put(">;[", ChatEmotion.Angry);
		emotions.put(">;(", ChatEmotion.Angry);
		emotions.put(">=(", ChatEmotion.Angry);
		
		emotions.put(":o", ChatEmotion.Shocked);
		emotions.put(";o", ChatEmotion.Shocked);
		emotions.put(">;o", ChatEmotion.Shocked);
		emotions.put(">:o", ChatEmotion.Shocked);
		emotions.put(">=o", ChatEmotion.Shocked);
		emotions.put("=o", ChatEmotion.Shocked);
		
		emotions.put(";'(", ChatEmotion.Sad);
		emotions.put(";[", ChatEmotion.Sad);
		emotions.put(":[", ChatEmotion.Sad);
		emotions.put(";(", ChatEmotion.Sad);
		emotions.put("=(", ChatEmotion.Sad);
		emotions.put("='(", ChatEmotion.Sad);
		emotions.put(":(", ChatEmotion.Sad);
		emotions.put(":-(", ChatEmotion.Sad);
		
		emotions.put(";D", ChatEmotion.Laugh);
		emotions.put(":D", ChatEmotion.Laugh);
		emotions.put(":L", ChatEmotion.Laugh);
	}
	
	public int getEmotion(String message) {	
		for(Map.Entry<String, ChatEmotion> emotion : emotions.entrySet()) {
			if(message.toLowerCase().contains(emotion.getKey())) {
				return getPacketForEmotion(emotion.getValue());
			}
		}
		return 0;
	}
	
	public int getPacketForEmotion(ChatEmotion e) {
		if(e.equals(ChatEmotion.Smile))
			return 1;
		
		else if(e.equals(ChatEmotion.Angry))
			return 2;
		
		else if(e.equals(ChatEmotion.Shocked))
			return 3;
		
		else if(e.equals(ChatEmotion.Sad))
			return 4;
		
		else if(e.equals(ChatEmotion.Laugh))
			return 6;
		
		else
			return 0;
		
	}
}
