package com.sulake.habbo.users.components;

import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Map;

import com.sulake.habbo.Habbo;
import com.sulake.habbo.communication.headers.Composers;
import com.sulake.habbo.communication.messages.types.Composer;
import com.sulake.habbo.flats.items.definitions.types.ItemDefinition;
import com.sulake.habbo.users.components.types.InventoryItem;
import com.sulake.sessions.types.Session;

public class InventoryComponent {
	public Map<Integer, InventoryItem> wallItems;
	public Map<Integer, InventoryItem> floorItems;
	
	public InventoryComponent(int userId) {

		this.wallItems = new HashMap<Integer, InventoryItem>();
		this.floorItems = new HashMap<Integer, InventoryItem>();
		
		try {
			ResultSet row = Habbo.getCore().getDatabase().readTable("SELECT * FROM habbo_items WHERE owner_id = " + userId);
			
			while(row.next()) {
				this.addItem(row.getInt("id"), row.getString("item_name"), row.getInt("item_id"));
			}
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void addItem(int Id, String displayName, int itemId) {
		try {
			ItemDefinition item = Habbo.getCore().getItems().getDefinition(itemId);
			InventoryItem invItem = new InventoryItem(Id, item, displayName);
		
			if(item.ItemType.equals("s")) {
				this.getFloorItems().put(invItem.Id, invItem);
			}
			
			if(item.ItemType.equals("i")) {
				this.getWallItems().put(invItem.Id, invItem);
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public Map<Integer, InventoryItem> getWallItems() {
		return this.wallItems;
	}
	
	public Map<Integer, InventoryItem> getFloorItems() {
		return this.floorItems;
	}

	public void removeItem(InventoryItem item, Session client) {
		Habbo.getCore().getDatabase().executeQuery("DELETE FROM habbo_items WHERE id = " + item.Id);
		
		if(item.getBaseItem().ItemType.equals("s")) {
			this.getFloorItems().remove(item.Id);
		}
		
		if(item.getBaseItem().ItemType.equals("i")) {
			this.getWallItems().remove(item.Id);
		}
		
		Composer msg = new Composer(Composers.RemoveObjectFromInventoryMessageComposer);
		msg.appendInt32(item.Id);
		client.send(msg);	
	}

	public void dispose() {
		this.getFloorItems().clear();
		this.getWallItems().clear();
		
		this.wallItems = null;
		this.floorItems = null;
	}
}
