package com.sulake.habbo.users.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import com.sulake.habbo.Habbo;
import com.sulake.habbo.Core;
import com.sulake.habbo.users.types.User;

public class UserDao {

	public static User loadUserByTicket(String ticket) {
		
		String _ticket = Core.clean(ticket);
		
		ResultSet result = Habbo.getCore().getDatabase().readRow("SELECT * FROM habbos WHERE session_ticket = '" + _ticket + "' LIMIT 1");
		
		User user = UserDao.loadUserByResult(result);
		
		UserDao.nullField("session_ticket", user.getId());
		
		return user;
	}
	
	public static User loadUserById(int Id) {
	
		ResultSet result = Habbo.getCore().getDatabase().readRow("SELECT * FROM habbos WHERE id = " + Id + " LIMIT 1");
		
		User user = UserDao.loadUserByResult(result);
		
		return user;
	}
	
	public static User loadUserByUsername(String username) {
		
		ResultSet result = Habbo.getCore().getDatabase().readRow("SELECT * FROM habbos WHERE username = '" + Core.clean(username) + "' LIMIT 1");
		
		User user = UserDao.loadUserByResult(result);
		
		return user;
	}
	
	public static boolean ticketExists(String ticket) {
		return Habbo.getCore().getDatabase().entryExists("SELECT id FROM habbos WHERE session_ticket = '" + ticket + "' LIMIT 1");
	}
	
	public static User loadUserByResult(ResultSet data) {
		
		try {
			return new User(data.getInt("id"), data.getString("username"), data.getString("figure"), data.getString("motto"), data.getString("gender"), data.getInt("rank"), data.getInt("credits"), data.getInt("vip_points"), data.getInt("pixels"));
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return null;
	}
	
	public static void nullField(String field, int id) {
		try {
			Habbo.getCore().getDatabase().executeQuery("UPDATE habbos SET `" + field + "` = null WHERE id = " + id);
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void updateUserStatus(boolean status, int id) {
		
		if(status) {
			Habbo.getCore().getDatabase().executeQuery("UPDATE habbos SET online = '1' WHERE id = " + id);
		} else {
			Habbo.getCore().getDatabase().executeQuery("UPDATE habbos SET online = '0' WHERE id = " + id);
		}
		
	}
	
}
