package com.sulake.habbo.users.ranks;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.sulake.habbo.database.DatabaseManager;
import com.sulake.habbo.users.ranks.types.Rank;
import com.sulake.habbo.utilities.Logger;

public class RankManager {
	public Map<Integer, Rank> ranks;
	
	public RankManager() {
		this.ranks = new HashMap<Integer, Rank>();
	}
	
	public void loadAll(DatabaseManager databaseManager) {
		ResultSet row = databaseManager.readTable("SELECT * FROM `ranks`");
		if(row != null) {
			try {
				while(row.next()) {
					
					List<String> permissions = new ArrayList<String>();
					
					ResultSet perms = databaseManager.readTable("SELECT * FROM `rank_permissions` WHERE name = '" + row.getString("permission_set") + "' LIMIT 1");
					while(perms.next()) {
						for(String permission : perms.getString("permissions").split(";")) {
							permissions.add(permission);
						}
					}
					
					Rank r = new Rank(row.getInt("id"), row.getString("name"), permissions);
					this.getRanks().put(r.Id, r);
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
		Logger.write("Loaded " + this.getRanks().size() + " rank definitions");
	}
	
	public Rank getRank(int Id) {
		if(this.getRanks().containsKey(Id)) {
			return this.getRanks().get(Id);
		} else {
			return null;
		}
	}
	
	public Map<Integer, Rank> getRanks() {
		return this.ranks;
	}
}
